import java.util.ArrayList;
import java.util.List;

import junit.framework.Assert;


public class AssertionTracker {
	static ThreadLocal<List<String>> failures = new ThreadLocal<List<String>>();
	static boolean active;

	public static boolean isActive() {
		return failures.get() != null;
	}


	public static void fail(String string) {
		lazyFailures().add(string);
	}


	private static List<String> lazyFailures() {
		if (failures.get()  == null) {
			failures.set(new ArrayList<String>());
		}
		return failures.get();
	}


	public static void activate() {
		failures.set(new ArrayList<String>());
	}


	public static void report() {
		List<String> list = failures.get();
		failures.set(null);
		if (!list.isEmpty()) {
			Assert.fail("There were several failures: " + list);
		}
	}

}
