import java.util.List;

import junit.framework.Assert;
import junit.framework.TestFailure;

import org.junit.runner.Description;
import org.junit.runner.notification.Failure;
import org.junit.runner.notification.RunNotifier;
import org.junit.runners.BlockJUnit4ClassRunner;
import org.junit.runners.model.FrameworkMethod;
import org.junit.runners.model.InitializationError;

public class MultiAssertTestRunner extends BlockJUnit4ClassRunner {

	public MultiAssertTestRunner(Class<?> testClass) throws InitializationError {
		super(testClass);
	}

	@Override
	protected void runChild(FrameworkMethod method, RunNotifier notifier) {
		AssertionTracker.activate();
		super.runChild(method, notifier);
		notifier.fireTestFailure(new Failure(Description.createTestDescription(
				getTestClass().getJavaClass(), method.getName()),
				new Exception("Uff da")));
		notifier.fireTestFailure(new Failure(Description.createTestDescription(
				getTestClass().getJavaClass(), method.getName()),
				new Exception("Uff da")));
		AssertionTracker.report();
	}

	public static void myAssertEquals(List<Integer> expected,
			List<Integer> actual) {
		boolean areEqual = expected.equals(actual); // placeholder
		if (areEqual)
			return;

		if (AssertionTracker.isActive()) {
			AssertionTracker.fail("They are not equal!");
		} else {
			Assert.fail("They are not equal!");
		}

	}

}
